// Generated by dts-bundle v0.7.3

declare module '@material/base' {
    /**
      * @license
      * Copyright 2019 Google Inc.
      *
      * Permission is hereby granted, free of charge, to any person obtaining a copy
      * of this software and associated documentation files (the "Software"), to deal
      * in the Software without restriction, including without limitation the rights
      * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
      * copies of the Software, and to permit persons to whom the Software is
      * furnished to do so, subject to the following conditions:
      *
      * The above copyright notice and this permission notice shall be included in
      * all copies or substantial portions of the Software.
      *
      * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
      * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
      * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
      * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
      * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
      * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
      * THE SOFTWARE.
      */
    export * from '@material/base/component';
    export * from '@material/base/foundation';
    export * from '@material/base/types';
}

declare module '@material/base/component' {
    /**
        * @license
        * Copyright 2016 Google Inc.
        *
        * Permission is hereby granted, free of charge, to any person obtaining a copy
        * of this software and associated documentation files (the "Software"), to deal
        * in the Software without restriction, including without limitation the rights
        * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
        * copies of the Software, and to permit persons to whom the Software is
        * furnished to do so, subject to the following conditions:
        *
        * The above copyright notice and this permission notice shall be included in
        * all copies or substantial portions of the Software.
        *
        * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
        * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
        * THE SOFTWARE.
        */
    import { MDCFoundation } from '@material/base/foundation';
    import { CustomEventListener, EventType, SpecificEventListener } from '@material/base/types';
    export class MDCComponent<FoundationType extends MDCFoundation> {
            root: Element;
            static attachTo(root: Element): MDCComponent<MDCFoundation<{}>>;
            protected foundation: FoundationType;
            constructor(root: Element, foundation?: FoundationType, ...args: unknown[]);
            initialize(..._args: Array<unknown>): void;
            getDefaultFoundation(): FoundationType;
            initialSyncWithDOM(): void;
            destroy(): void;
            /**
                * Wrapper method to add an event listener to the component's root element. This is most useful when
                * listening for custom events.
                */
            listen<K extends EventType>(evtType: K, handler: SpecificEventListener<K>, options?: AddEventListenerOptions | boolean): void;
            listen<E extends Event>(evtType: string, handler: CustomEventListener<E>, options?: AddEventListenerOptions | boolean): void;
            /**
                * Wrapper method to remove an event listener to the component's root element. This is most useful when
                * unlistening for custom events.
                */
            unlisten<K extends EventType>(evtType: K, handler: SpecificEventListener<K>, options?: AddEventListenerOptions | boolean): void;
            unlisten<E extends Event>(evtType: string, handler: CustomEventListener<E>, options?: AddEventListenerOptions | boolean): void;
            /**
                * Fires a cross-browser-compatible custom event from the component root of the given type, with the given data.
                */
            emit<T extends object>(evtType: string, evtData: T, shouldBubble?: boolean): void;
    }
    export default MDCComponent;
}

declare module '@material/base/foundation' {
    /**
        * @license
        * Copyright 2016 Google Inc.
        *
        * Permission is hereby granted, free of charge, to any person obtaining a copy
        * of this software and associated documentation files (the "Software"), to deal
        * in the Software without restriction, including without limitation the rights
        * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
        * copies of the Software, and to permit persons to whom the Software is
        * furnished to do so, subject to the following conditions:
        *
        * The above copyright notice and this permission notice shall be included in
        * all copies or substantial portions of the Software.
        *
        * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
        * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
        * THE SOFTWARE.
        */
    export class MDCFoundation<AdapterType extends {} = {}> {
            protected adapter: AdapterType;
            static get cssClasses(): {
                    [key: string]: string;
            };
            static get strings(): {
                    [key: string]: string;
            };
            static get numbers(): {
                    [key: string]: number;
            };
            static get defaultAdapter(): {};
            constructor(adapter?: AdapterType);
            init(): void;
            destroy(): void;
    }
    /**
        * The constructor for MDCFoundation.
        */
    export interface MDCFoundationConstructor<AdapterType extends object = any> {
            new (adapter: AdapterType): MDCFoundation<AdapterType>;
            readonly prototype: MDCFoundation<AdapterType>;
    }
    /**
        * The deprecated constructor for MDCFoundation.
        */
    export interface MDCFoundationDeprecatedConstructor<AdapterType extends object = any> {
            readonly cssClasses: Record<string, string>;
            readonly strings: Record<string, string>;
            readonly numbers: Record<string, number>;
            readonly defaultAdapter: AdapterType;
            new (adapter?: Partial<AdapterType>): MDCFoundation<AdapterType>;
            readonly prototype: MDCFoundation<AdapterType>;
    }
    /**
        * Retrieves the AdapaterType from the provided MDCFoundation generic type.
        */
    export type MDCFoundationAdapter<T> = T extends MDCFoundation<infer A> ? A : never;
    export default MDCFoundation;
}

declare module '@material/base/types' {
    /**
        * @license
        * Copyright 2019 Google Inc.
        *
        * Permission is hereby granted, free of charge, to any person obtaining a copy
        * of this software and associated documentation files (the "Software"), to deal
        * in the Software without restriction, including without limitation the rights
        * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
        * copies of the Software, and to permit persons to whom the Software is
        * furnished to do so, subject to the following conditions:
        *
        * The above copyright notice and this permission notice shall be included in
        * all copies or substantial portions of the Software.
        *
        * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
        * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
        * THE SOFTWARE.
        */
    export type EventType = keyof GlobalEventHandlersEventMap;
    export type SpecificEventListener<K extends EventType> = (evt: GlobalEventHandlersEventMap[K]) => void;
    export type CustomEventListener<E extends Event> = (evt: E) => void;
    export type WindowEventType = keyof WindowEventMap;
    export type SpecificWindowEventListener<K extends WindowEventType> = (evt: WindowEventMap[K]) => void;
    /**
        * A generic type for the constructor of an instance type. Note that this type
        * does not preserve accurate constructor parameters.
        *
        * @template T The instance type.
        */
    export type Constructor<T = any> = {
            new (...args: any[]): T;
    };
}

